# -*- coding: UTF-8 -*-

import ConfigParser
import os
from artix.common import logger

location = 'cash'

defaultLoggerConf = {
    'version': 1,
    'loggers': {
        '': {  # root logger
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'saleUnloadmain': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'saleUnloadNode': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadmain': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadNode': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadrest': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadsoap': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadRestStatusService': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'Service': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dict.rest.backup': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        }
    },
    'handlers': {
        'exchangersHandler': {
            'level': 'DEBUG',
            'formatter': 'exchangersFormatter',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/tmp/exchangers.log',
            'mode': 'a',
            'maxBytes': 5000000,
            'backupCount': 10
        }
    },
    'formatters': {
        'exchangersFormatter': {
            'format': '%(asctime)s %(thread)d %(levelname)-8s %(message)s %(module)5s(%(lineno)s)'
        }
    }
}


def getLogDirectory():
    config = ConfigParser.RawConfigParser()
    configPath = os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/%s/exchangers.ini' % location)
    if not config.read(configPath):
        print(u"Configuration file '%s' not found." % configPath)
    sectionName = 'main'
    paramName = 'logDirectory'
    return config.get(sectionName, paramName) if config.has_section(sectionName) and config.has_option(sectionName, paramName) else '/tmp/exchangers'


def getUploadLogger(name, fileName=None):
    return getLogger(name, 'dictLoad', fileName)


def getUnloadLogger(name, fileName=None):
    return getLogger(name, 'saleUnload', fileName)


def getLogger(name, prefix='', fileName=None):
    name = prefix + name
    fileName = os.path.join(getLogDirectory(), ((prefix + fileName) if fileName else name) + '.log')
    return logger.SimpleLogger(fileName, name,
            configPath=os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/%s/logging.properties' % location),
            dictConfigObject=defaultLoggerConf).getLogger()
