import os
import sys

from unloadService import UnloadService

from common import logger, config

logger.location = 'cs'
import traceback


def main():
    errorLog = logger.getUploadLogger('errorLog', 'RestError')
    if not config.read(os.path.normpath(sys.path[0] + "/../config/cs/exchangers.ini")):
        errorLog.error("Configuration file 'exchangers.ini' not found. The system 'exchangers' is not running.")
        exit(1)
    try:
        UnloadService().on_start()
    except Exception as e:
        print(e)
        errorLog.error(traceback.format_exc())


if __name__ == '__main__':
    main()
