import os
import sys
sys.path[0] = os.path.normpath('%s/../../..' % sys.path[0])

from common import logger
logger.location = 'cs'

from common import config
from upload.fam import soapService
import traceback


def main():
    errorSoapLog = logger.getUploadLogger('errorLog', 'SoapError')
    if not config.read(sys.path[0] + "/../config/cs/exchangers.ini"):
        errorSoapLog.error("Configuration file 'exchangers.ini' not found. The system 'exchangers' is not running.")
        exit(1)

    try:
        soapService.start(isCash=False)
    except:
        errorSoapLog.error(traceback.format_exc())


if __name__ == '__main__':
    main()
